# About real world setup docs

hledger and plain text accounting tools generally are highly flexible
and don't impose much structure or process. This can make it hard to
get started.

In this part of the site, you can read about file layouts, account
organisations, workflows and routines that have been effective for
other hledger users in practice. You may like to try replicating one
of these exactly, or simply read for ideas.

These docs are not required to be complete, reproducible, or
maintained (although that is welcome), but they should give some
insight about setups or processes that you found useful in practice.

Here's a rough template to provide ideas:

```
Author:       X  
Last updated: DATE  

## Requirements

Tested on:    PLATFORM(S)  
Tested with:  HLEDGER VERSION  
Tools used: 
hledger, 
hledger-ui, 
GNU make, 
sed..

## Files

`tree` output..

## Data entry / conversion

How I capture data..

## Version control

How I use version control, if any

## Accounts

Account hierarchy used, any organisational principles, how I maintain it..

## Reports

The main reports used ?

## Tasks / Workflows

How to do ..

## Routines

Recurring (daily, weekly, monthly, yearly..) workflows
```
